package ru.landrafhomyak.kotlin.utilities

import kotlin.jvm.JvmField

public class ByteVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmField
	public var value: Byte
) {
	@Suppress("MemberVisibilityCanBePrivate")
	public fun getAndSet(newValue: Byte): Byte {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	public fun getAndAdd(d: Byte): Byte = this.getAndSet((this.value + d).trimToByte())
	public fun getAndSub(d: Byte): Byte = this.getAndSet((this.value - d).trimToByte())
}

public class UByteVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	public var value: UByte
) {
	@Suppress("MemberVisibilityCanBePrivate")
	public fun getAndSet(newValue: UByte): UByte {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	public fun getAndAdd(d: UByte): UByte = this.getAndSet((this.value + d).trimToUByte())
	public fun getAndSub(d: UByte): UByte = this.getAndSet((this.value - d).trimToUByte())
}

public class ShortVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmField
	public var value: Short
) {
	@Suppress("MemberVisibilityCanBePrivate")
	public fun getAndSet(newValue: Short): Short {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	public fun getAndAdd(d: Short): Short = this.getAndSet((this.value + d).trimToShort())
	public fun getAndSub(d: Short): Short = this.getAndSet((this.value - d).trimToShort())
}

public class UShortVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	public var value: UShort
) {
	@Suppress("MemberVisibilityCanBePrivate")
	public fun getAndSet(newValue: UShort): UShort {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	public fun getAndAdd(d: UShort): UShort = this.getAndSet((this.value + d).trimToUShort())
	public fun getAndSub(d: UShort): UShort = this.getAndSet((this.value - d).trimToUShort())
}

public class IntVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmField public var value: Int
) {
	@Suppress("MemberVisibilityCanBePrivate")
	public fun getAndSet(newValue: Int): Int {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	public fun getAndAdd(d: Int): Int = this.getAndSet(this.value + d)
	public fun getAndSub(d: Int): Int = this.getAndSet(this.value - d)
}

public class UIntVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	public var value: UInt
) {
	@Suppress("MemberVisibilityCanBePrivate")
	public fun getAndSet(newValue: UInt): UInt {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	public fun getAndAdd(d: UInt): UInt = this.getAndSet(this.value + d)
	public fun getAndSub(d: UInt): UInt = this.getAndSet(this.value - d)
}

public class LongVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmField
	public var value: Long
) {
	@Suppress("MemberVisibilityCanBePrivate")
	public fun getAndSet(newValue: Long): Long {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	public fun getAndAdd(d: Long): Long = this.getAndSet(this.value + d)
	public fun getAndSub(d: Long): Long = this.getAndSet(this.value - d)
}

public class ULongVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	public var value: ULong
) {
	@Suppress("MemberVisibilityCanBePrivate")
	public fun getAndSet(newValue: ULong): ULong {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	public fun getAndAdd(d: ULong): ULong = this.getAndSet(this.value + d)
	public fun getAndSub(d: ULong): ULong = this.getAndSet(this.value - d)
}